#ifndef 	_FILTER_H
#define _FILTER_H

#include <linux/types.h>
#include <linux/mutex.h>

#define RULE_EXC 1
#define RULE_INC 2
#define IS_RULE_VALID(rule)  ((rule==RULE_EXC)||(rule == RULE_INC))


#define FILTER_ENABLE 1
#define FILTER_DISABLE 0



//filter error codes
#define FILTER_PASS 100
#define FILTER_BLOCK 101


typedef struct  scsi_cmd_filter{
	int rule;
	unsigned int codeslen;
	int enable;
	char *codes; 
	struct mutex filter_lock;
	

}scsi_cmd_filter_t;

 int is_rule_valid(int rule);

int is_filter_enable(struct scsi_cmd_filter * filter);

void enable_filter(struct scsi_cmd_filter * filter);
void disable_filter(struct scsi_cmd_filter * filter);


int alloc_filter(int rule, char * codes, int codeslen, struct scsi_cmd_filter ** filter);

void free_filter(struct scsi_cmd_filter * filter);

int modify_filter(struct scsi_cmd_filter * filter, int newrule, char * newcodes, int newcodeslen);

int do_filter(struct scsi_cmd_filter * filter, char code);


#endif
