#ifndef _SCSI_HOOKER_H
#define _SCSI_HOOKER_H

#include <linux/kernel.h>
#include <linux/module.h>
#include <linux/spinlock.h>


#include <scsi/scsi.h>
#include <scsi/scsi_host.h>
#include <scsi/scsi_device.h>
#include <linux/err.h>


typedef struct scsi_hooker{
	struct list_head list;
	struct Scsi_Host * host;

  int (* queuecommand_backup)(struct scsi_cmnd *,
						     void (*done)(struct scsi_cmnd *));
	int (*hooker_fn)(struct scsi_cmnd *cmd,
					void (*done)(struct scsi_cmnd *));

} scsi_hooker_t;

int default_hook_fn(struct scsi_cmnd *cmd,
					void (*done)(struct scsi_cmnd *));


struct scsi_hooker * alloc_hooker(void);
void free_hooker(struct scsi_hooker * hooker);
void add_hooker(struct scsi_hooker * hooker);
struct scsi_hooker * get_scsihooker_by_hostno(int hostno);




#endif
