#include "scsi_codes.h"

char* scsi_cmd_names[]= {"TEST_UNIT_READY       ",
"REZERO_UNIT           ",
"REQUEST_SENSE         ",
"FORMAT_UNIT           ",
"READ_BLOCK_LIMITS     ",
"REASSIGN_BLOCKS       ",
"READ_6                ",
"WRITE_6               ",
"SEEK_6                ",
"READ_REVERSE          ",
"WRITE_FILEMARKS       ",
"SPACE                 ",
"INQUIRY               ",
"RECOVER_BUFFERED_DATA ",
"MODE_SELECT           ",
"RESERVE               ",
"RELEASE               ",
"COPY                  ",
"ERASE                 ",
"MODE_SENSE            ",
"START_STOP            ",
"RECEIVE_DIAGNOSTIC    ",
"SEND_DIAGNOSTIC       ",
"ALLOW_MEDIUM_REMOVAL  ",
"SET_WINDOW            ",
"READ_CAPACITY         ",
"READ_10               ",
"WRITE_10              ",
"SEEK_10               ",
"WRITE_VERIFY          ",
"VERIFY                ",
"SEARCH_HIGH           ",
"SEARCH_EQUAL          ",
"SEARCH_LOW            ",
"SET_LIMITS            ",
"PRE_FETCH             ",
"READ_POSITION         ",
"SYNCHRONIZE_CACHE     ",
"LOCK_UNLOCK_CACHE     ",
"READ_DEFECT_DATA      ",
"MEDIUM_SCAN           ",
"COMPARE               ",
"COPY_VERIFY           ",
"WRITE_BUFFER          ",
"READ_BUFFER           ",
"UPDATE_BLOCK          ",
"READ_LONG             ",
"WRITE_LONG            ",
"CHANGE_DEFINITION     ",
"WRITE_SAME            ",
"READ_TOC              ",
"LOG_SELECT            ",
"LOG_SENSE             ",
"MODE_SELECT_10        ",
"RESERVE_10            ",
"RELEASE_10            ",
"MODE_SENSE_10         ",
"PERSISTENT_RESERVE_IN ",
"PERSISTENT_RESERVE_OUT",
"REPORT_LUNS           ",
"MOVE_MEDIUM           ",
"READ_12               ",
"WRITE_12              ",
"WRITE_VERIFY_12       ",
"SEARCH_HIGH_12        ",
"SEARCH_EQUAL_12       ",
"SEARCH_LOW_12         ",
"READ_ELEMENT_STATUS   ",
"SEND_VOLUME_TAG       ",
"WRITE_LONG_2          ",
"READ_16               ",
"WRITE_16              ",
"VERIFY_16	           ",
"SERVICE_ACTION_IN     "
}; 


char scsi_cmd_codes[]={
		0x00,  
		0x01,  
		0x03,  
		0x04,  
		0x05,  
		0x07,  
		0x08,  
		0x0a,  
		0x0b,  
		0x0f,  
		0x10,  
		0x11,  
		0x12,  
		0x14,  
		0x15,  
		0x16,  
		0x17,  
		0x18,  
		0x19,  
		0x1a,  
		0x1b,  
		0x1c,  
		0x1d,  
		0x1e,  
		0x24,  
		0x25,  
		0x28,  
		0x2a,  
		0x2b,  
		0x2e,  
		0x2f,  
		0x30,  
		0x31,  
		0x32,  
		0x33,  
		0x34,  
		0x34,  
		0x35,  
		0x36,  
		0x37,  
		0x38,  
		0x39,  
		0x3a,  
		0x3b,  
		0x3c,  
		0x3d,  
		0x3e,  
		0x3f,  
		0x40,  
		0x41,  
		0x43,  
		0x4c,  
		0x4d,  
		0x55,  
		0x56,  
		0x57,  
		0x5a,  
		0x5e,  
		0x5f, 
		0xa0,  
		0xa5,  
		0xa8,  
		0xaa,  
		0xae,  
		0xb0,  
		0xb1,  
		0xb2,  
		0xb8,  
		0xb6,  
		0xea,  
		0x88,  
		0x8a,  
		0x8f,    
		0x9e
};

char scsi_cmd_unknown[] = {"UNKNOWN COMMAND"};
char * scsi_code_to_name(char code){
		int i;
		for(i = 0; i < sizeof(scsi_cmd_codes); i++){
			if(scsi_cmd_codes[i] == code){
				return scsi_cmd_names[i];
			}
		}

		return scsi_cmd_unknown;
}

int find_code(char code){
	int i;
	for(i = 0; i < sizeof(scsi_cmd_codes); i ++){
		if(code == scsi_cmd_codes[i]){
				return i;
		}
	}

	return UNKNOWN_CODE;

}
